package com.myapp;

import java.util.Arrays;
import java.util.Collection;

import org.junit.Test;
import org.junit.Before;

import org.junit.runners.Parameterized;
import org.junit.runners.Parameterized.Parameters;
import org.junit.runner.RunWith;
import static org.junit.Assert.assertEquals;

@RunWith(Parameterized.class)
public class ParameterizedClass {
  private Integer inputNumber;
  private Boolean expectedResult;
  private Calculator calculator;

  @Before
  public void initialize() {
    calculator = new Calculator();
  }

  @Parameterized.Parameters
  public static Collection primeNumbers() {
    return Arrays.asList(new Object[][] {
            { 3, true },
            { 11, true },
            { 59, true },
            { 4, false },
            { 12, false }
    });
  }

  public ParameterizedClass(Integer inputNumber, Boolean expectedResult) {
    this.inputNumber = inputNumber;
    this.expectedResult = expectedResult;
  }

  @Test
  public void primeNumberTest() {
    System.out.println(inputNumber);
    assertEquals(expectedResult,
            calculator.isPrime(inputNumber));
  }

}
